#version 300 es

precision highp float;

uniform float u_Time;
uniform vec2 u_Resolution;
uniform sampler2D u_Texture; // clamp

uniform float u_SFT;

in vec2 v_TexCoord;

layout(location = 0) out vec4 o_FragColor;

float map(float value, float inMin, float inMax, float outMin, float outMax) {
    return (value - inMin) * (outMax - outMin) / (inMax - inMin) + outMin;
}


float SFT = 5.0;

float a = 1.0;

vec4 prev(vec2 p) {

    if( p.x>=u_Resolution.x || p.y>=u_Resolution.y) {
        return vec4(vec3(1.), texture(u_Texture, (p+.5)/u_Resolution.xy).a);
    }

    if( p.x<0. || p.y<0.) {
        return vec4(vec3(0.), texture(u_Texture, (p+.5)/u_Resolution.xy).a);
    }

    return texture(u_Texture, (p+.5)/u_Resolution.xy);

}

bool odd(float x) {
    return (mod(x, 2.0) < 1.0);
}

float cv(vec3 c) {
    return c.r+c.g+c.b;
} //color value

vec3 compare(vec3 c1, vec3 c2, int c){
    if(c==1) return (cv(c1) < cv(c2)) ? c1: c2*.5;
    else     return (cv(c1) > cv(c2)) ? c1: c2*.5;
}

vec3 sort0(vec2 p, int c){
    vec4 c1 = prev(p), c2 = prev(p +vec2( (c==1)?SFT:-SFT, 0.) );

    a = (c1.a + c2.a) / 2.0;

    return compare(c1.rgb, c2.rgb, c);
}
vec3 sort1(vec2 p, int c){
    vec3 c1 = sort0(p,c), c2 = sort0(p+vec2( (c==1)?SFT:-SFT, 0.) , c);
    return compare(c1, c2, c);
}
vec3 sort2(vec2 p, int c){
    vec3 c1 = sort1(p,c), c2 = sort1(p+vec2( (c==1)?SFT:-SFT, 0.) , c);
    return compare(c1, c2, c);
}
vec3 sort3(vec2 p, int c){
    vec3 c1 = sort2(p, c), c2 = sort2(p+vec2((c==1)?SFT:-SFT, 0.), c);
    return compare(c1, c2, c);
}

void main() {
    SFT = map(u_SFT, 0.0, 1.0, -10.0, 10.0);

    vec2 p = vec2(floor(gl_FragCoord.x),floor(gl_FragCoord.y));
    int cnd = ( odd(p.x) ^^ odd(u_Time*50.) )? 1: 0;//condition
    vec3 c = sort3(p, cnd);
    o_FragColor = vec4(c, a);
}
