#version 300 es

precision highp float;

uniform float u_Time;
uniform vec2 u_Resolution;
uniform sampler2D u_Texture; // clamp

uniform float u_Coeff1; // 16.0
uniform float u_Coeff2; // 8.0
uniform float u_Coeff3; // 8.0
uniform float u_Coeff4; // 0.03
uniform float u_Coeff5; // 0.03 * 0.16666666
uniform float u_Coeff6; // 0.03

in vec2 v_TexCoord;

layout(location = 0) out vec4 o_FragColor;

float rand(vec2 co){
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453) * 2.0 - 1.0;
}

float offset(float blocks, vec2 uv) {
    return rand(vec2(u_Time, floor(uv.y * blocks)));
}

float map(float value, float inMin, float inMax, float outMin, float outMax) {
    return (value - inMin) * (outMax - outMin) / (inMax - inMin) + outMin;
}


void main() {
    float coeff1 = map(u_Coeff1, 0.0, 1.0, 2.0, 64.0);
    float coeff2 = map(u_Coeff2, 0.0, 1.0, 2.0, 64.0);
    float coeff3 = map(u_Coeff3, 0.0, 1.0, 2.0, 64.0);
    float coeff4 = map(u_Coeff4, 0.0, 1.0, 0.0, 0.1);
    float coeff5 = map(u_Coeff5, 0.0, 1.0, 0.0, 0.1);
    float coeff6 = map(u_Coeff6, 0.0, 1.0, 0.0, 0.1);

    vec2 uv = gl_FragCoord.xy / u_Resolution.xy;

    o_FragColor = texture(u_Texture, uv);

    vec2 r = texture(u_Texture, uv + vec2(offset(coeff1, uv) * coeff4, 0.0)).ra;
    vec2 g = texture(u_Texture, uv + vec2(offset(coeff2, uv) * coeff5, 0.0)).ga;
    vec2 b = texture(u_Texture, uv + vec2(offset(coeff3, uv) * coeff6, 0.0)).ba;

    o_FragColor.r = r.x;
    o_FragColor.g = g.x;
    o_FragColor.b = g.x;
    o_FragColor.a = (r.y + g.y + b.y) / 3.0;
}
